'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _chai = require('chai');

var _sinon = require('sinon');

var _sinon2 = _interopRequireDefault(_sinon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (testDescription, func, argsArray, expected, test, _ref) {
  var getSpy = _ref.getSpy;

  test(testDescription, function () {
    var injectableSpy = _sinon2.default.spy();

    var argsWithSpy = argsArray.map(function (arg) {
      return arg && arg.indexOf('spy') === 0 ? injectableSpy : arg;
    });

    func.apply(null, argsWithSpy);

    (0, _chai.expect)(injectableSpy.called).to.equal(expected === 'true');
  });
};