'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.testEvalSpy = testEvalSpy;

var _chai = require('chai');

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// @t "woo" testEvalSpy(spy('bar')) ~expects expect(spy('bar').calledOnce).to.equal(true)
// @t "woo" testEvalSpy(spy('baz'), {leet: 1337}) ~expects expect(spy('baz').args[0]).to.eql(['foo', {leet: 1337}])
// @t "woo" testEvalSpy(spy('far')) ~expects spy('far').calledOnce
function testEvalSpy(fn, obj) {
  fn('foo', obj);
}

/* istanbul ignore next */

exports.default = function (testDescription, func, argsArray, expected, test, _ref) {
  var getSpy = _ref.getSpy;

  test(testDescription, function () {
    func.apply(null, argsArray);
    var spyName = expected.split('.')[0];
    var spy = getSpy;

    if (!spy) {
      throw new Error('ERROR: Could not find a spy named ' + spyName + '.');
    }

    (function evaluate() {
      // eslint-disable-next-line no-eval
      eval('\n        const expect = this.expect;\n        const assert = this.assert;\n        const spy = this.spy;\n\n        ' + (expected.indexOf('expect(') > 0 ? expected : 'assert(' + expected + ')') + '\n        ');
    }).call({
      expect: _chai.expect,
      spy: spy,
      assert: _assert2.default
    });
  });
};